package com.sun.jmx.snmp.internal;

import com.sun.jmx.snmp.SnmpSecurityException;
import com.sun.jmx.snmp.SnmpStatusException;
import com.sun.jmx.snmp.SnmpTooBigException;
import com.sun.jmx.snmp.SnmpSecurityParameters;

public interface SnmpSecurityModel extends SnmpModel
{
    public abstract int generateRequestMsg(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, SnmpSecurityParameters p6, byte[] p7, byte[] p8, byte[] p9, int p10, byte[] p11) throws SnmpTooBigException, SnmpStatusException, SnmpSecurityException;
    
    public abstract int generateResponseMsg(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, SnmpSecurityParameters p6, byte[] p7, byte[] p8, byte[] p9, int p10, byte[] p11) throws SnmpTooBigException, SnmpStatusException, SnmpSecurityException;
    
    public abstract SnmpSecurityParameters processIncomingRequest(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, byte[] p6, byte[] p7, byte[] p8, byte[] p9, byte[] p10, SnmpDecryptedPdu p11) throws SnmpStatusException, SnmpSecurityException;
    
    public abstract SnmpSecurityParameters processIncomingResponse(SnmpSecurityCache p0, int p1, int p2, int p3, byte p4, int p5, byte[] p6, byte[] p7, byte[] p8, byte[] p9, byte[] p10, SnmpDecryptedPdu p11) throws SnmpStatusException, SnmpSecurityException;
    
    public abstract SnmpSecurityCache createSecurityCache();
    
    public abstract void releaseSecurityCache(SnmpSecurityCache p0);
}
